#include "bits/stdc++.h"

using namespace std;

int main() {
  long long N, M, K;
  cin >> N >> M >> K;

  // Mnożymy ilość ryb przez 2, aby wszystkie operacje
  // wykonywać na liczbach całkowitych.
  M *= 2;

  // Dopóki mamy zasoby (pieniądze, ryby)
  // oraz możemy wykonywać operacje (K)
  while (N > 0 && M > 0 && K > 0) {
    // Liczymy ile ryb możemy kupić.
    // Pamiętamy że ilość ryb jest podwojona.
    long long moge_kupic = min(N, M);

    // Aktualizujemy ile pieniędzy mamy.
    N -= moge_kupic;
    // Oraz ile ryb mamy po tej transakcji.
    // Pamiętamy że ilość ryb jest podwojona.
    M += moge_kupic;
    // Oraz zmniejszamy liczbę dostępnych operacji.
    K -= 1;
  }

  // Finalnie wypisujemy wynik w formacie z jedną
  // cyfrą po przecinku.
  cout << M / 2 << "." << (M % 2 == 0 ? "0" : "5") << "\n";

  return 0;
}
